<route lang="yaml">
meta:
  enabled: false
</route>

<script lang="ts" setup>
import { ElMessage } from 'element-plus'
import type { FormInstance, FormRules } from 'element-plus'
import { createRole, getRoleById, updateRole } from '@/api/system/roleApi'
const emit = defineEmits(['success'])

const formRef = ref<FormInstance>()
const formRules = ref<FormRules>({
  roleName: [
    { required: true, message: '请输入标题', trigger: 'blur' },
  ],
  roleDesc: [
    { required: false, message: '请输入描述', trigger: 'blur' },
  ],
})

const state = reactive({
  title: '',
  dialogVisible: false,
  loading: false,
  formData: {
    roleId: 0,
    roleName: '',
    roleDesc: '',
  },
  actionType: 1,
})

onMounted(() => {})

const getData = async (roleId: number) => {
  state.loading = true
  const { data } = await getRoleById(roleId)
  state.loading = false
  state.formData = data
}

function onSubmit() {
  formRef.value && formRef.value.validate(async (valid) => {
    if (valid) {
      if (state.actionType === 1) {
        await createRole(state.formData)
        state.dialogVisible = false
        emit('success')
      }
      else {
        await updateRole(state.formData)
        state.dialogVisible = false
        emit('success')
      }
      ElMessage.success({
        message: '保存成功',
        center: true,
      })
    }
  })
}

function onCancel() {
  state.dialogVisible = false
}

function resetFormData() {
  state.formData = {
    roleId: 0,
    roleName: '',
    roleDesc: '',
  }
}

defineExpose({
  showAddModel() {
    resetFormData()
    state.title = '新增角色'
    state.actionType = 1
    state.dialogVisible = true
  },
  showEditModel(roleId: number) {
    resetFormData()
    state.title = '编辑角色'
    state.actionType = 2
    state.dialogVisible = true
    getData(roleId)
  },
})
</script>

<template>
  <div>
    <el-dialog v-model="state.dialogVisible" :title="state.title" width="600px" :close-on-click-modal="false" append-to-body destroy-on-close>
      <div v-loading="state.loading">
        <el-form ref="formRef" :model="state.formData" :rules="formRules" label-width="120px" label-suffix="：">
          <el-form-item label="角色名称" prop="roleName">
            <el-input v-model="state.formData.roleName" placeholder="请输入标题" />
          </el-form-item>

          <el-form-item label="简要说明" prop="roleDesc">
            <el-input v-model="state.formData.roleDesc" type="textarea" rows="10" placeholder="请输入标题" />
          </el-form-item>
        </el-form>
      </div>

      <template #footer>
        <el-button size="large" @click="onCancel">
          取消
        </el-button>
        <el-button type="primary" size="large" @click="onSubmit">
          保存
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
